/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.stat.handler;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.xml.sax.SAXException;

import benten.cat.stat.model.WordCountModel;
import benten.core.model.Xliff;
import blanco.xliff.valueobject.BlancoXliffTransUnit;

/**
 * ワード数取得ハンドラーです。
 */
public class ShowWordCountHandler extends AbstractStatHandler<WordCountModel> {

	@Override
	protected WordCountModel processFile(File file) throws IOException, SAXException {
		Xliff xliff = Xliff.loadInstance(file);
		List<BlancoXliffTransUnit> unitList = xliff.getAllTransUnitList();
		WordCountModel model = new WordCountModel();
		model.setFile(file);
		for (BlancoXliffTransUnit unit : unitList) {
			String source = unit.getSource();
			if (source != null) {
				model.setWordCount(model.getWordCount() + splitWord(source).length);
			}
		}
		return model;
	}
}
