/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.stat.views;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

import benten.cat.stat.model.GlossaryHitRateModel;
import benten.ui.views.TableLabelProvider;

public class GlossaryHitRateView extends AbstractStatView {

	@Override
	protected void createTableViewer(TableViewer viewer) {
		final Table table = viewer.getTable();

		TableColumn resource = new TableColumn(table, SWT.LEFT);
		resource.setText("リソース");
		resource.setWidth(150);

		TableColumn hit_75 = new TableColumn(table, SWT.RIGHT);
		hit_75.setText(">= 75%");
		hit_75.setWidth(70);

		TableColumn hit_50 = new TableColumn(table, SWT.RIGHT);
		hit_50.setText(">= 50%");
		hit_50.setWidth(70);

		TableColumn hit_25 = new TableColumn(table, SWT.RIGHT);
		hit_25.setText(">= 25%");
		hit_25.setWidth(70);

		TableColumn hitUnder_25 = new TableColumn(table, SWT.RIGHT);
		hitUnder_25.setText("< 25%");
		hitUnder_25.setWidth(70);

		viewer.setLabelProvider(new TableLabelProvider() {
			public String getColumnText(Object obj, int index) {
				GlossaryHitRateModel entry = (GlossaryHitRateModel) obj;
				switch (index) {
				case 0:
					return entry.getFile().toString();
				case 1:
					return String.valueOf(entry.getHit_75());
				case 2:
					return String.valueOf(entry.getHit_50());
				case 3:
					return String.valueOf(entry.getHit_25());
				case 4:
					return String.valueOf(entry.getHitUnder_25());
				}
				return getText(obj);
			}
		});
	}
}
