/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.stat.views;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

import benten.cat.stat.model.TranslationRateModel;
import benten.ui.views.TableLabelProvider;

public class TranslationRateView extends AbstractStatView {

	@Override
	protected void createTableViewer(TableViewer viewer) {
		final Table table = viewer.getTable();

		TableColumn resource = new TableColumn(table, SWT.LEFT);
		resource.setText("リソース");
		resource.setWidth(150);

		TableColumn transUnit = new TableColumn(table, SWT.RIGHT);
		transUnit.setText("翻訳単位");
		transUnit.setWidth(60);

		TableColumn untranslated = new TableColumn(table, SWT.RIGHT);
		untranslated.setText("未翻訳");
		untranslated.setWidth(60);

		TableColumn untranslatedRate = new TableColumn(table, SWT.RIGHT);
		untranslatedRate.setText("未翻訳率");
		untranslatedRate.setWidth(60);

		TableColumn working = new TableColumn(table, SWT.RIGHT);
		working.setText("翻訳中");
		working.setWidth(60);

		TableColumn workingRate = new TableColumn(table, SWT.RIGHT);
		workingRate.setText("翻訳中率");
		workingRate.setWidth(60);

		TableColumn translated = new TableColumn(table, SWT.RIGHT);
		translated.setText("翻訳済");
		translated.setWidth(60);

		TableColumn translatedRate = new TableColumn(table, SWT.RIGHT);
		translatedRate.setText("翻訳済率");
		translatedRate.setWidth(60);

		viewer.setLabelProvider(new TableLabelProvider() {
			public String getColumnText(Object element, int columnIndex) {
				TranslationRateModel entry = (TranslationRateModel) element;
				switch (columnIndex) {
				case 0:
					return entry.getFile().toString();
				case 1:
					return String.valueOf(entry.getTransUnit());
				case 2:
					return String.valueOf(entry.getUntranslated());
				case 3:
					return entry.getUntranslatedRate() + "%";
				case 4:
					return String.valueOf(entry.getWorking());
				case 5:
					return entry.getWorkingRate() + "%";
				case 6:
					return String.valueOf(entry.getTranslated());
				case 7:
					return entry.getTranslatedRate() + "%";
				}
				return getText(element);
			}
		});
	}
}
