/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.stat.views;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

import benten.cat.stat.model.WordCountModel;
import benten.ui.views.TableLabelProvider;

public class WordCountView extends AbstractStatView {

	@Override
	protected void createTableViewer(TableViewer viewer) {
		final Table table = viewer.getTable();

		TableColumn resource = new TableColumn(table, SWT.LEFT);
		resource.setText("リソース");
		resource.setWidth(150);

		TableColumn wordCount = new TableColumn(table, SWT.RIGHT);
		wordCount.setText("ワード数");
		wordCount.setWidth(70);

		viewer.setLabelProvider(new TableLabelProvider() {
			public String getColumnText(Object obj, int index) {
				WordCountModel entry = (WordCountModel) obj;
				switch (index) {
				case 0:
					return entry.getFile().toString();
				case 1:
					return String.valueOf(entry.getWordCount());
				}
				return getText(obj);
			}
		});
	}
}
